%{

/* includes and declarations go here */

#include "calc.h"

#define YY_USER_ACTION \
  yyloc->last_column += yyleng;

%}

DIGIT   [0-9]
INT     {DIGIT}+
FLOAT   {DIGIT}+\.{DIGIT}*

%%

%{
  /* this code goes at the beginning of the function yylex */
  yyloc->first_line = yyloc->last_line;
  yyloc->first_column = yyloc->last_column;
%}

  /* comments need to be indented */

  /* a set of dummy rules */

"\n"      { yyloc->last_line++; yyloc->last_column = 0; return EOL; }
[ \t]*    { /* ignore whitespace */ }
{INT}     { yylval->val = atoi(yytext); return INT; }
{FLOAT}   { yylval->val = atof(yytext); return FLOAT; }
\+        { return PLUS; }
-         { return MINUS; }
\*        { return TIMES; }
\/        { return DIV; }
\(        { return LPAR; }
\)        { return RPAR; }

.         { fprintf(stderr, "/!\\ invalid character\n"); }

%%

  /* No C code needed */

